/*
 Tecnisa - Tecnologia em Informtica

 Nome: Importa_Fluxo_Ajuste

 Descrio:
  Atualiza os ajustes dos boletos a Receber e Pagar,
  nas respectivas tabelas MOVFXAJBOLR e MOVFXAJBOLP.

-- @C:\WIN_PRJ\SQL\ORACLE\0000_FINTMP_IMPORTA_FLUXO_AJUSTE.SQL;
-- EXECUTE IMPORTA_FLUXO_AJUSTE
-- SET SERVEROUTPUT ON
-- DBMS_OUTPUT.PUT_LINE('xx');

 */

CREATE OR REPLACE PROCEDURE IMPORTA_FLUXO_AJUSTE
AS
   V_ACHOUP       NUMBER;
   V_ACHOUR       NUMBER;
   V_CTFLUXO      NUMBER;
   V_VRAJBOLPAG   NUMBER;
   V_VRAJBOLREC   NUMBER;
   V_VRAJANTE     NUMBER;
   V_VRAJNOVO     NUMBER;
   V_CDCLASSFINA  VARCHAR2(06);

   CURSOR C_AJBOLPAG IS
      SELECT
         AJ.CDFILIAL,    AJ.NRLANBOLPAG,  AJ.CDAJUCTPAG,
         AJ.CDCLASSFINA, AJ.CDEMMFAJBOLP, AJ.CDFIMFAJBOLP,
         AJ.DTMOVFLUXO,  AJ.IDMOVFLUXO,   AJ.VRAJBOLPAG,
         TA.IDAJUCTPAG
      FROM TIPOAJPAGAR TA, AJBOLPAG AJ
      WHERE AJ.CDAJUCTPAG = TA.CDAJUCTPAG
      ORDER BY AJ.CDFILIAL, AJ.NRLANBOLPAG, AJ.CDAJUCTPAG;

   CURSOR C_AJBOLREC IS
      SELECT
         AJ.CDFILIAL,    AJ.NRLANBOLREC,  AJ.CDAJUCTREC,
         AJ.CDCLASSFINA, AJ.CDEMMFAJBOLR, AJ.CDFIMFAJBOLR,
         AJ.DTMOVFLUXO,  AJ.IDMOVFLUXO,   AJ.VRAJBOLREC,
         TR.IDAJUCTREC
      FROM TIPOAJRECEBER TR, AJBOLREC AJ
      WHERE AJ.CDAJUCTREC = TR.CDAJUCTREC
      ORDER BY AJ.CDFILIAL, AJ.NRLANBOLREC, AJ.CDAJUCTREC;

   CURSOR C_AJCTPAG IS
      SELECT
         AJ.CDFILIAL,    AJ.NRLANCTONF,   AJ.NRSEQVENPAG,  AJ.NRPARCELAPAG, AJ.DTAJUSTEPAG,
         AJ.CDAJUCTPAG,  AJ.DSAJUSTEPAG,  AJ.VRAJUSTEPAG,  AJ.CDECTBAJPAG,  AJ.NRLCTBAJPAG,
         AJ.CDCLASSFINA, AJ.CDEMMFAJCNTP, AJ.CDFIMFAJCNTP, AJ.DTMOVFLUXO,   AJ.IDMOVFLUXO,
         TA.IDAJUCTPAG
      FROM TIPOAJPAGAR TA, AJCTPAGAR AJ
      WHERE TA.CDAJUCTPAG = AJ.CDAJUCTPAG;

   CURSOR C_AJCTREC IS
      SELECT
         AJ.CDFILIAL,    AJ.NRLANCTONF,   AJ.DTAJUSTEREC,  AJ.CDAJUCTREC,  AJ.DSAJUSTEREC,
         AJ.VRAJUSTEREC, AJ.CDECTBAJREC,  AJ.NRLCTBAJREC,  AJ.NRSEQVENREC, AJ.NRPARCELAREC,
         AJ.CDCLASSFINA, AJ.CDEMMFAJCNTR, AJ.CDFIMFAJCNTR, AJ.DTMOVFLUXO,  AJ.IDMOVFLUXO,
         TA.IDAJUCTREC
      FROM TIPOAJRECEBER TA, AJCTRECEBER AJ
      WHERE TA.CDAJUCTREC = AJ.CDAJUCTREC;
BEGIN
   FOR C_AJBOLP IN C_AJBOLPAG LOOP
      SELECT
         COUNT(*)
      INTO
         V_ACHOUP
      FROM
         MOVFXAJBOLP MA
      WHERE
         (C_AJBOLP.CDFILIAL    = MA.CDFILIBOLPAG) AND
         (C_AJBOLP.NRLANBOLPAG = MA.NRLANBOLPAG)  AND
         (C_AJBOLP.CDAJUCTPAG  = MA.CDAJUCTPAG);

      IF V_ACHOUP = 0 THEN
         IF C_AJBOLP.CDCLASSFINA IS NOT NULL THEN
            IF C_AJBOLP.IDAJUCTPAG = 'A' THEN
               V_VRAJBOLPAG := C_AJBOLP.VRAJBOLPAG * -1;
            ELSE
               V_VRAJBOLPAG := C_AJBOLP.VRAJBOLPAG;
            END IF;

            ATUALIZA_FLUXO_DE_CAIXA(C_AJBOLP.CDEMMFAJBOLP, C_AJBOLP.CDFIMFAJBOLP,
                                    C_AJBOLP.DTMOVFLUXO,   C_AJBOLP.IDMOVFLUXO,
                                    C_AJBOLP.CDCLASSFINA,  0,  V_VRAJBOLPAG);
         END IF;

         FOR C_RATP IN (SELECT AJ.CDFILIAL, AJ.NRLANBOLPAG, AJ.CDAJUCTPAG,
                          AJ.VRAJBOLPAG,   CP.CDCLASSFINA, CP.CDEMPRESA,
                          CP.CDFIMOVFLPAG, CP.DTMOVFLUXO,  CP.IDMOVFLUXO,
                          TA.IDAJUCTPAG,   CP.IDSTATPAG,
                          DECODE(MAX(BP.VRBOLPAG), 0, 0,
                                (MAX(AJ.VRAJBOLPAG) * SUM(CP.VRATUAPAG))/ MAX(BP.VRBOLPAG)) VRRATAJBOLPAG
                       FROM
                          CONTAPAGAR  CP, BOLETPAGAR BP,
                          TIPOAJPAGAR TA, AJBOLPAG   AJ
                       WHERE
                          (AJ.CDFILIAL     = C_AJBOLP.CDFILIAL)    AND
                          (AJ.NRLANBOLPAG  = C_AJBOLP.NRLANBOLPAG) AND
                          (AJ.CDAJUCTPAG   = C_AJBOLP.CDAJUCTPAG)  AND
                          (TA.CDAJUCTPAG   = AJ.CDAJUCTPAG)  AND
                          (BP.CDFILIAL     = AJ.CDFILIAL)    AND
                          (BP.NRLANBOLPAG  = AJ.NRLANBOLPAG) AND
                          (CP.CDFILIBPAG   = BP.CDFILIAL)    AND
                          (CP.NRLANBOLPAG  = BP.NRLANBOLPAG)
                       GROUP BY
                          AJ.CDFILIAL,     AJ.NRLANBOLPAG, AJ.CDAJUCTPAG,
                          AJ.VRAJBOLPAG,   CP.CDCLASSFINA, CP.CDEMPRESA,
                          CP.CDFIMOVFLPAG, CP.DTMOVFLUXO,  CP.IDMOVFLUXO,
                          TA.IDAJUCTPAG,   CP.IDSTATPAG) LOOP

            IF C_AJBOLP.CDCLASSFINA IS NOT NULL THEN
               IF C_RATP.IDAJUCTPAG = 'A' THEN
                  V_VRAJBOLPAG := ROUND(C_RATP.VRRATAJBOLPAG, 2);
               ELSE
                  V_VRAJBOLPAG := ROUND(C_RATP.VRRATAJBOLPAG * -1, 2);
               END IF;

               ATUALIZA_FLUXO_DE_CAIXA(C_RATP.CDEMPRESA,   C_RATP.CDFIMOVFLPAG,
                                       C_RATP.DTMOVFLUXO,  C_RATP.IDMOVFLUXO,
                                       C_RATP.CDCLASSFINA, 0, V_VRAJBOLPAG);
            END IF;

            INSERT INTO MOVFXAJBOLP
               (CDCLASSFINA, CDEMPRESA,  CDFILIAL,
                DTMOVFLUXO,  IDMOVFLUXO, CDFILIBOLPAG,
                NRLANBOLPAG, CDAJUCTPAG, VRFXAJBOLPAG)
            VALUES
               (C_RATP.CDCLASSFINA, C_RATP.CDEMPRESA,  C_RATP.CDFIMOVFLPAG,
                C_RATP.DTMOVFLUXO,  C_RATP.IDMOVFLUXO, C_RATP.CDFILIAL,
                C_RATP.NRLANBOLPAG, C_RATP.CDAJUCTPAG, ROUND(C_RATP.VRRATAJBOLPAG, 2));
         END LOOP;
      END IF;
   END LOOP;

   FOR C_AJBOLR IN C_AJBOLREC LOOP
      SELECT
         COUNT(*)
      INTO
         V_ACHOUR
      FROM
         MOVFXAJBOLR MA
      WHERE
         (C_AJBOLR.CDFILIAL    = MA.CDFILIBOLREC) AND
         (C_AJBOLR.NRLANBOLREC = MA.NRLANBOLREC)  AND
         (C_AJBOLR.CDAJUCTREC  = MA.CDAJUCTREC);
      IF V_ACHOUR = 0 THEN
         IF C_AJBOLR.CDCLASSFINA IS NOT NULL THEN
            IF C_AJBOLR.IDAJUCTREC = 'A' THEN
               V_VRAJBOLREC := C_AJBOLR.VRAJBOLREC * -1;
            ELSE
               V_VRAJBOLREC := C_AJBOLR.VRAJBOLREC;
            END IF;

            ATUALIZA_FLUXO_DE_CAIXA(C_AJBOLR.CDEMMFAJBOLR, C_AJBOLR.CDFIMFAJBOLR,
                                    C_AJBOLR.DTMOVFLUXO,   C_AJBOLR.IDMOVFLUXO,
                                    C_AJBOLR.CDCLASSFINA,  V_VRAJBOLREC, 0);
         END IF;

         FOR C_RATR IN (SELECT AJ.CDFILIAL, AJ.NRLANBOLREC, AJ.CDAJUCTREC,
                          AJ.VRAJBOLREC,   CR.CDCLASSFINA, CR.CDEMPRESA,
                          CR.CDFIMOVFLREC, CR.DTMOVFLUXO,  CR.IDMOVFLUXO,
                          TA.IDAJUCTREC,   CR.IDSTATREC,
                          DECODE(MAX(BR.VRBOLREC), 0, 0,
                                (MAX(AJ.VRAJBOLREC) * SUM(CR.VRATUAREC))/ MAX(BR.VRBOLREC)) VRRATAJBOLREC
                       FROM
                          CONTARECEBER  CR, BOLETRECEBER BR,
                          TIPOAJRECEBER TA, AJBOLREC   AJ
                       WHERE
                          (AJ.CDFILIAL     = C_AJBOLR.CDFILIAL)    AND
                          (AJ.NRLANBOLREC  = C_AJBOLR.NRLANBOLREC) AND
                          (AJ.CDAJUCTREC   = C_AJBOLR.CDAJUCTREC)  AND
                          (TA.CDAJUCTREC   = AJ.CDAJUCTREC)  AND
                          (BR.CDFILIAL     = AJ.CDFILIAL)    AND
                          (BR.NRLANBOLREC  = AJ.NRLANBOLREC) AND
                          (CR.CDFILIBOLREC = BR.CDFILIAL)    AND
                          (CR.NRLANBOLREC  = BR.NRLANBOLREC)
                       GROUP BY
                          AJ.CDFILIAL,     AJ.NRLANBOLREC, AJ.CDAJUCTREC,
                          AJ.VRAJBOLREC,   CR.CDCLASSFINA, CR.CDEMPRESA,
                          CR.CDFIMOVFLREC, CR.DTMOVFLUXO,  CR.IDMOVFLUXO,
                          TA.IDAJUCTREC,   CR.IDSTATREC) LOOP

            IF C_AJBOLR.CDCLASSFINA IS NOT NULL THEN
               IF C_RATR.IDAJUCTREC = 'A' THEN
                  V_VRAJBOLREC := ROUND(C_RATR.VRRATAJBOLREC, 2);
               ELSE
                  V_VRAJBOLREC := ROUND(C_RATR.VRRATAJBOLREC * -1, 2);
               END IF;

               ATUALIZA_FLUXO_DE_CAIXA(C_RATR.CDEMPRESA,   C_RATR.CDFIMOVFLREC,
                                       C_RATR.DTMOVFLUXO,  C_RATR.IDMOVFLUXO,
                                       C_RATR.CDCLASSFINA, V_VRAJBOLREC, 0);
            END IF;

            INSERT INTO MOVFXAJBOLR
               (CDCLASSFINA, CDEMPRESA,  CDFILIAL,
                DTMOVFLUXO,  IDMOVFLUXO, CDFILIBOLREC,
                NRLANBOLREC, CDAJUCTREC, VRFXAJBOLREC)
            VALUES
               (C_RATR.CDCLASSFINA, C_RATR.CDEMPRESA,  C_RATR.CDFIMOVFLREC,
                C_RATR.DTMOVFLUXO,  C_RATR.IDMOVFLUXO, C_RATR.CDFILIAL,
                C_RATR.NRLANBOLREC, C_RATR.CDAJUCTREC, ROUND(C_RATR.VRRATAJBOLREC, 2));
         END LOOP;
      END IF;
   END LOOP;

   FOR C_AJCTP IN C_AJCTPAG LOOP
      SELECT CDCLASSFINA INTO V_CDCLASSFINA
      FROM CONTAPAGAR
      WHERE
         CDFILIAL     = C_AJCTP.CDFILIAL     AND
         NRLANCTONF   = C_AJCTP.NRLANCTONF   AND
         NRSEQVENPAG  = C_AJCTP.NRSEQVENPAG  AND
         NRPARCELAPAG = C_AJCTP.NRPARCELAPAG;

      IF C_AJCTP.CDCLASSFINA <> V_CDCLASSFINA THEN
         IF C_AJCTP.IDAJUCTPAG = 'A' THEN
            V_VRAJANTE  := C_AJCTP.VRAJUSTEPAG * -1;
            V_VRAJNOVO  := C_AJCTP.VRAJUSTEPAG;
         ELSE
            V_VRAJANTE  := C_AJCTP.VRAJUSTEPAG;
            V_VRAJNOVO  := C_AJCTP.VRAJUSTEPAG * -1;
         END IF;
         ATUALIZA_FLUXO_DE_CAIXA(C_AJCTP.CDEMMFAJCNTP, C_AJCTP.CDFIMFAJCNTP,
                                 C_AJCTP.DTMOVFLUXO,   C_AJCTP.IDMOVFLUXO,
                                 C_AJCTP.CDCLASSFINA,  0,  V_VRAJANTE);

         ATUALIZA_FLUXO_DE_CAIXA(C_AJCTP.CDEMMFAJCNTP, C_AJCTP.CDFIMFAJCNTP,
                                 C_AJCTP.DTMOVFLUXO,   C_AJCTP.IDMOVFLUXO,
                                 V_CDCLASSFINA,  0,  V_VRAJNOVO);

         UPDATE AJCTPAGAR
         SET CDCLASSFINA = V_CDCLASSFINA
         WHERE
            CDFILIAL     = C_AJCTP.CDFILIAL     AND
            NRLANCTONF   = C_AJCTP.NRLANCTONF   AND
            NRSEQVENPAG  = C_AJCTP.NRSEQVENPAG  AND
            NRPARCELAPAG = C_AJCTP.NRPARCELAPAG AND
            DTAJUSTEPAG  = C_AJCTP.DTAJUSTEPAG  AND
            CDAJUCTPAG   = C_AJCTP.CDAJUCTPAG;
      END IF;
   END LOOP;

   FOR C_AJCTR IN C_AJCTREC LOOP
      SELECT CDCLASSFINA INTO V_CDCLASSFINA
      FROM CONTARECEBER
      WHERE
         CDFILIAL     = C_AJCTR.CDFILIAL     AND
         NRLANCTONF   = C_AJCTR.NRLANCTONF   AND
         NRSEQVENREC  = C_AJCTR.NRSEQVENREC  AND
         NRPARCELAREC = C_AJCTR.NRPARCELAREC;

      IF C_AJCTR.CDCLASSFINA <> V_CDCLASSFINA THEN
         IF C_AJCTR.IDAJUCTREC = 'A' THEN
            V_VRAJANTE  := C_AJCTR.VRAJUSTEREC * -1;
            V_VRAJNOVO  := C_AJCTR.VRAJUSTEREC;
         ELSE
            V_VRAJANTE  := C_AJCTR.VRAJUSTEREC;
            V_VRAJNOVO  := C_AJCTR.VRAJUSTEREC * -1;
         END IF;

         ATUALIZA_FLUXO_DE_CAIXA(C_AJCTR.CDEMMFAJCNTR, C_AJCTR.CDFIMFAJCNTR,
                                 C_AJCTR.DTMOVFLUXO,   C_AJCTR.IDMOVFLUXO,
                                 C_AJCTR.CDCLASSFINA,  V_VRAJANTE, 0);

         ATUALIZA_FLUXO_DE_CAIXA(C_AJCTR.CDEMMFAJCNTR, C_AJCTR.CDFIMFAJCNTR,
                                 C_AJCTR.DTMOVFLUXO,   C_AJCTR.IDMOVFLUXO,
                                 V_CDCLASSFINA,  V_VRAJNOVO, 0);

         UPDATE AJCTRECEBER
         SET CDCLASSFINA = V_CDCLASSFINA
         WHERE
            CDFILIAL     = C_AJCTR.CDFILIAL     AND
            NRLANCTONF   = C_AJCTR.NRLANCTONF   AND
            NRSEQVENREC  = C_AJCTR.NRSEQVENREC  AND
            NRPARCELAREC = C_AJCTR.NRPARCELAREC AND
            DTAJUSTEREC  = C_AJCTR.DTAJUSTEREC  AND
            CDAJUCTREC   = C_AJCTR.CDAJUCTREC;
      END IF;
   END LOOP;
END;
/

BEGIN
IMPORTA_FLUXO_AJUSTE;
END;
/

COMMIT
/

-- VERSAO --
BEGIN ATUVEROBJ('IMPORTA_FLUXO_AJUSTE','4.09.066'); END;
/

